#!/usr/bin/perl

# Form mailer v1.1 (Oct-05-2006)
# Copyright (c) 1999-2006 Oshii Tokuma
#  Web site: http://kan-chan.stbbs.net/download/
#
# This program is free software; you can redistribute it and/or 
# modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation; either version 2 of 
# the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, 
# but WITHOUT ANY WARRANTY; without even the implied warranty of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with this program; if not, write to the Free 
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

############################################################
# Settings you may need to modify if necessary             #
# KvɉĕύX鍀                                 #
############################################################

# Language (JP/EN)
#  (JP/EN)

$language = 'JP';
#$language = 'EN';


# Path to jcode.pl (Japanese code converter)
# If $language isn't 'JP', you can comment out this line
# jcode.pl({R[hRo[^)̃pX
# $language'JP'łȂ΃RgAEgĂ悢

require './jcode.pl';


# Email address to send message
# bZ[Ẅ̓dq[AhX

$mailto = 'input@your.address.here';


# Path to sendmail
# sendmail̃pX

$sendmail = '/usr/sbin/sendmail';


# CSS file
# CSS t@C
#$css = "style_en.css";
$css = "style_ja.css";

# If one control named 'email' exists on the input form, the value 
# of the control is treated as sender's email address.
# Also, value of a control named 'subject' is treated as a subject 
# of the email.
# 'email'ƂÕRg[̓tH[ɑ݂ꍇA
# ̃Rg[̒l͑Mdq[AhXɂȂ܂B
# ܂A'subject'Rg[̒l͓dq[̃AhXɂȂ܂B

# Allow leaving 'email' blank (0:NG / 1:OK)
# 'email'ڂ󔒂ł悢 (0:NG / 1:OK)

$email_blank_ok = 1;


# Default email address of sender ('email') if blank
# M('email')󔒂̎̃ftHg̃[AhX

$default_sender = 'anonymous@on.the.net';


# Maximum content length of the POST data
# POSTf[^̍ől

$max_post_length = 1000000;


# Spam filter: Disallow sending messages with these strings
# XptB^: ̕܂ރbZ[W͑M֎~

@disallow_str_table = (
'\[url=',
'\<a href\='
);


############################################################

# Error messages
# G[bZ[W

%ERROR = (
'ENtoo_long', 'Cannot accept data.  Message is too long.',
'ENdisallowed_to_send', 'Cannot send message.',
'ENget_method', 'GET method is disabled for security reason. Use POST method.', 
'ENwrong_email', 'Email address may be blank or in wrong format.',
'ENsendmail_error', 'Cannot call sendmail.',

'JPtoo_long', 'bZ[W߂邽߁Af[^󂯕t邱Ƃł܂B',
'JPdisallowed_to_send', 'bZ[W𑗐Mł܂łB',
'JPget_method', 'GET\bh̓ZLeB̗RŖɂȂĂ܂BPOST\bhgpĂB',
'JPwrong_email', 'dq[AhX󔒂邢͖Ȍ`łB邢͑Spœ͂Ă邩܂B',
'JPsendmail_error', 'sendmailNł܂łB',
);


# Read from form
# tH[̓ǂݍ

if ($ENV{'CONTENT_LENGTH'} > $max_post_length){
	&error('Error', $ERROR{$language . 'too_long'});
}

if ($ENV{'REQUEST_METHOD'} eq "POST"){
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
} else{
# GET method is disabled for security reason
#	$buffer = $ENV{'QUERY_STRING'};

	if ($buffer eq ''){
		&frm_comment;
	} else{
		&error('Error', $ERROR{$language . 'get_method'});
	}
}

$lines = "";

@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {
	($name,$value) = split(/=/,$pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	if ($value =~ /\r\n/){
		$value =~ s/\r//g;
	}
	if ($value =~ /\r/){
		$value =~ s/\r/\n/g;
	}
	if ($value =~ /\n/){
		$lines .= "($name)";
		$lines .= "\n---------------------------------------------------------------------------\n";
		$lines .= $value;
		$lines .= "\n---------------------------------------------------------------------------\n";
	} else{
		$lines .= "($name)  $value\n";
		$in{$name} = $value;
	}
}

# Spam filter
foreach (@disallow_str_table) {
	if ($lines =~ /$_/i){
		&error('Error', $ERROR{$language . 'disallowed_to_send'});
		exit;
	}
}


# Convert ".\n" -> ". \n"
$lines =~ s/(^|\n)\.(\n|$)/$1. $2/g;
$lines =~ s/(^|\n)\.(\n|$)/$1. $2/g;

$email = $in{'email'};
$subject = $in{'subject'};
if ($subject eq ''){ $subject = 'Form posted from FormMail'; }
if (($email eq '') || !($email =~ /(.*)\@(.*)\.(.*)/)) {
	if ($email_blank_ok == 0){
		&error('Error', $ERROR{$language . 'wrong_email'});
	} else{
		$email = $default_sender;
	}
}


# Send mail via sendmail
# sendmailoRŃ[M

if (!open(OUT, "| $sendmail -t")){
	&error('Error', $ERROR{$language . 'sendmail_error'});
}
print OUT <<"EOF";
To: <$mailto>
From: <$email>
Return-Path: <$email>
Errors-To: <$mailto>
X-Mailer: FormMailer v1.1  (c) 1999-2006 Oshii Tokuma
Subject: $subject
EOF

if ($language eq 'EN') {
	print OUT "Content-Type: text/plain; charset=\"US-ASCII\"\n";
	print OUT "Content-Transfer-Encoding: 7bit\n";
}
if ($language eq 'JP') {
	print OUT "Content-Type: text/plain; charset=\"ISO-2022-JP\"\n";
	print OUT "Content-Transfer-Encoding: 7bit\n";
}

&encode(*lines);

print OUT "\n\n\n$lines\n";

print OUT <<"EOF";
---------------------------------------------------------------------------
REMOTE_HOST : $ENV{'REMOTE_HOST'} [$ENV{'REMOTE_ADDR'}]
HTTP_USER_AGENT : $ENV{'HTTP_USER_AGENT'}
HTTP_FORWARDED : $ENV{'HTTP_FORWARDED'}
HTTP_X_FORWARDED_FOR : $ENV{'HTTP_X_FORWARDED_FOR'}
HTTP_PROXY_CONNECTION : $ENV{'HTTP_PROXY_CONNECTION'}
HTTP_CACHE_INFO : $ENV{'HTTP_CACHE_INFO'}
HTTP_VIA : $ENV{'HTTP_VIA'}
HTTP_CLIENT_IP : $ENV{'HTTP_CLIENT_IP'}
---------------------------------------------------------------------------
EOF

close(OUT);


# Display result
# ʕ\

$MSG{'EN'} = <<"EOF";
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<link rel="stylesheet" href="$css" type="text/css">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Thank you</title>
</head>
<body>
<h1>Thank you</h1>

<p>Transmission of the following message is completed.</p>
<p>Click [Back] button on the browser.</p>
<hr>
<pre>
$lines
</pre>
</body>
</html>
EOF

$MSG{'JP'} = <<"EOF";
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
<link rel="stylesheet" href="$css" type="text/css">
<meta http-equiv="Content-Type" content="text/html; charset=shift_jis">
<title>肪Ƃ܂</title>
</head>
<body>
<h1>肪Ƃ܂</h1>

<p>ȉ̃bZ[W̑M܂B</p>
<p>uEU[߂]{^NbNĂB</p>
<hr>
<pre>
$lines
</pre>
</body>
</html>
EOF

print $MSG{$language};
exit;


# Display 'Comments, please' form
# uӌǂvtH[̕\

sub frm_comment{
	local(%MSG);
	$MSG{'EN'} = <<"EOF";
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<link rel="stylesheet" href="$css" type="text/css">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Comments, please</title>
</head>
<body>
<h1>Comments, please</h1>

<form method="POST" action="$ENV{'SCRIPT_NAME'}">

<dl>
<dt>Name:</dt>
<dd><input name="name" type="text" size="20"></dd>

<dt>Your E-mail address:</dt>
<dd><input name="email" type="text" size="60"></dd>

<dt>Your comments:</dt>
<dd><textarea name="comments" cols="60" rows="10"></textarea></dd>

<dt>Thank you.</dt>
<dd><input type=submit value="Send"></dd>
</dl>
</form>
</body>
</html>
EOF
	$MSG{'JP'} = <<"EOF";
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
<link rel="stylesheet" href="$css" type="text/css">
<meta http-equiv="Content-Type" content="text/html; charset=shift_jis">
<title>ӌǂ</title>
</head>
<body>
<h1>ӌǂ</h1><p>

<form method="POST" action="$ENV{'SCRIPT_NAME'}">

<dl>
<dt>O:</dt>
<dd><input name="name" type=text size="20"></dd>

<dt>dq[AhX:</dt>
<dd><input name="email" type=text size="60"></dd>

<dt>Rg:</dt>
<dd><textarea name="comments" cols=60 rows=10></textarea></dd>

<dt>肪Ƃ܂B</dt>
<dd><input type=submit value="M"></dd>
</dl>
</form>
</body>
</html>
EOF
	print $MSG{$language};
	exit;
}


# Display error message
# G[bZ[W\

sub error{
	if ($language eq 'EN') {
		print <<"EOF";
Content-type: text/html

<html>
<head>
<title>Error</title>
</head>
$body
<h1>$_[0]</h1>
<p>$_[1]</p>
<p>Click [Back] button on the browser.</p>
</body>
</html>
EOF
	}
	if ($language eq 'JP') {
		print <<"EOF";
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
<link rel="stylesheet" href="$css" type="text/css">
<meta http-equiv="Content-Type" content="text/html; charset=shift_jis">
<title>G[</title>
</head>
<body>
<h1>$_[0]</h1>
<p>$_[1]</p>
<p>uEU[߂]{^NbNĂB</p>
</body>
</html>
EOF
	}
	exit;
}


# convert Japanese code to JIS code
# {R[hJISR[h֕ϊ

sub encode{
	local(*s) = @_;
	if ($language eq "JP"){
		&jcode'convert(*msg, 'jis');
	}
}
